import	java.io.*;
import	javax.microedition.midlet.*;
import	javax.microedition.lcdui.*;
import	javax.microedition.io.*;
import	com.j_phone.amuse.ACanvas;
import	com.j_phone.system.DeviceControl;
import	com.j_phone.io.*;
import com.j_phone.ui.FEPControl ;


public  class  select  extends Canvas implements CommandListener, Runnable {
	private int currentFocus ;
	private int currentDisplay ;
	private String  currentDirectory = "" ;
	private String[] fileList ;
	private boolean  mediaRootFlag ;
//	private static final String[] mediaRoot = {"/ms/","/mc/"} ;
	private static final String[] mediaRoot = { StorageConnection.ROOT_INTERNAL, StorageConnection.ROOT_EXTERNAL} ;
	public view  vv ;
	private history  hh ;
	private Edit  edit ;

	public  select( view  myv) {
		vv = myv ;
		hh = new history( this) ;
		addCommand( new Command("Cancel", Command.SCREEN, 18)) ;
		addCommand( new Command("Open", Command.SCREEN, 19)) ;
		addCommand( new Command("Edit", Command.SCREEN, 20)) ;
		addCommand( new Command("History", Command.SCREEN, 21)) ;
		addCommand( new Command("New", Command.SCREEN, 22)) ;
//	3GCł̓tH_t@C邱Ƃ͂łȂ炵
		addCommand( new Command("Rename", Command.SCREEN, 23)) ;
		addCommand( new Command("Delete", Command.SCREEN, 24)) ;
		setCommandListener(this);

		edit = new Edit(myv);
		return ;
	}
	public void startSelect(){
		currentFocus = 0 ;
		currentDisplay = 0 ;
		mediaRootFlag = false ;
		currentDirectory = vv.textfile ;
		vv.lastopen = false ;
		if(  !currentDirectory.endsWith("/")){
			superDirectory() ;
		} else {
			openDirectory( currentDirectory) ;
		}
		if(!isFocusDisplay()){
			currentDisplay = currentFocus-vv.maxline+1 ;
		}
	}
	private void   openDirectory(String path){
		if( path.length()<2){
//	fBAIƂ납Ams=Amc=J[h
			currentDirectory = "" ;
			fileList = mediaRoot ;
			mediaRootFlag=true ;
			currentFocus = 1 ;
		} else {
			currentDirectory = path ;
			updateFileList() ;
		}
		return ;
	}
	private void  subDirectory(String path){
		mediaRootFlag=false;
		currentDirectory += path ;
		updateFileList() ;
		return ;
	}
	private void  superDirectory(){
		int index = currentDirectory.lastIndexOf('/', currentDirectory.length()-2) ;
		String lastDirectory = currentDirectory.substring( index+1) ;
		openDirectory( currentDirectory.substring( 0, index+1)) ;
		for( int i=fileList.length-1; i>=0; i--){
			if( lastDirectory.equals( fileList[i])){
				currentFocus = i+1 ;
				currentDisplay = 0 ;
				if(!isFocusDisplay()){
					currentDisplay = currentFocus-vv.maxline+1 ;
				}
				break ;
			}
		}
		return ;
	}
	private void  updateFileList(){
		StorageConnection conn = null;
		try {
			conn = (StorageConnection)Connector.open( "file://"+currentDirectory, Connector.READ) ;
			if( !conn.exists()){
				conn.close() ;conn=null ;
				currentDirectory = mediaRoot[0] ;
				updateFileList() ;
				return ;
			}
			fileList = conn.list();
			sortFileList() ;
		} catch (Exception e) {
{ /*e.getMessage()+": "+currentDirectory*/ };
		} finally {
			if (conn != null) {
				try { conn.close(); } catch (Exception e) {}
			}
		}
		return ;
	}
	public void  paint( Graphics g){
		g.setFont( vv.smallfont) ;
		g.setColor( vv.backcolor) ;
		g.fillRect( 0, 0, vv.width, vv.height) ;
		g.setColor(16743551) ; // 
		g.fillRect( 0, (currentFocus-currentDisplay)*vv.lineh+vv.footheight, vv.width, vv.lineh) ;
		g.setColor(12566463) ; // D
		g.fillRect( 0, 0, vv.width, vv.footheight) ;
		g.setColor( 0) ; // 
		g.drawString( currentDirectory, 0, 0, g.TOP|g.LEFT) ;
		g.drawString( currentFocus+"/"+fileList.length, vv.width, 0, g.TOP|g.RIGHT) ;
		g.setFont( vv.font) ;
		g.setColor( vv.textcolor) ;
		for( int i=0; i<fileList.length&&i<vv.maxline; i++){
			if( i+currentDisplay-fileList.length>=0){
				continue ;
			}
			g.drawString( fileList[i+currentDisplay], 0, (i+1)*vv.lineh+vv.footheight, g.TOP|g.LEFT) ;
		}
		if( mediaRootFlag){
			g.drawString( "MediaStorageSelect", 0, vv.footheight, g.TOP|g.LEFT) ;
		} else if(currentDisplay==0){
			g.drawString( "../", 0, vv.footheight, g.TOP|g.LEFT) ;
		} else {
			g.drawString( fileList[currentDisplay-1], 0, vv.footheight, g.TOP|g.LEFT) ;
		}
		return ;
	}
	public void  keyPressed(int keyCode){
		keyCode = getMyGameAction( keyCode) ;
		switch( keyCode){
			case  UP :
				if( currentFocus>=1){
					currentFocus--;
					if(!isFocusDisplay()){
						currentDisplay = currentFocus ;
					}
					break ;
				} else {
					currentFocus = fileList.length ;
					currentDisplay = currentFocus-vv.maxline+1 ;
					if( currentDisplay<0){
						currentDisplay= 0;
					}
					break ;
				}
			case  DOWN :
				if( currentFocus<fileList.length){
					currentFocus++;
					if(!isFocusDisplay()){
						currentDisplay = currentFocus-vv.maxline+1 ;
					}
					break ;
				} else {
					currentFocus=currentDisplay=0 ;
					break ;
				}
			case  LEFT :
//				currentFocus=currentDisplay=0;
//				keyPressed( FIRE) ;
				superDirectory();
				break ;
			case  RIGHT :
			case  FIRE :
				if( currentFocus==0){
					superDirectory();
					break ;
				} else if( !isFolder( fileList[currentFocus-1])){
					backtoView() ;
					return ;
				} else {
					subDirectory( fileList[currentFocus-1]) ;
					currentFocus=0; currentDisplay=0;
					break ;
				}
			case  KEY_POUND :
				if( currentFocus<=fileList.length-vv.maxline) {
					currentFocus = currentFocus + vv.maxline - 1 ;
				} else {
					currentFocus = fileList.length ;
				}
				if(!isFocusDisplay()){
					currentDisplay = currentFocus-vv.maxline+1 ;
				}
				break ;
			case  KEY_STAR :
				if( currentFocus>=vv.maxline){
					currentFocus = currentFocus - vv.maxline + 1 ;
				} else {
					currentFocus = 0 ;
				}
				if(!isFocusDisplay()){
					currentDisplay = currentFocus ;
				}
				break ;
			default:
				return ;
		}
		repaint() ;
		return ;
	}
	public void  keyRepeated(int keyCode){
		keyPressed( keyCode) ;
		return ;
	}
	private boolean isFocusDisplay(){
		if( currentFocus<currentDisplay || currentDisplay+vv.maxline-1<currentFocus){
			return  false ;
		} else {
			return  true ;
		}
	}
	private void showDialogEdit(){
		if( fileList[currentFocus-1].endsWith(".txt") || fileList[currentFocus-1].endsWith(".TXT")){
			vv.lastopen = true ;
			backtoEdit();
			return ;
		} else {
			List lt = new List( "*.txtłȂt@CҏW܂B", Choice.IMPLICIT) ;
			lt.append("܂킸J",null) ;
			lt.append("LZ",null) ;
			lt.setSelectedIndex( 1, true) ;
			lt.setCommandListener(this) ;
			Display.getDisplay(vv.mld).setCurrent(lt) ;
			return ;
		}
	}
	public void commandAction( Command c, Displayable d){
		if( c == List.SELECT_COMMAND){
			List lt = (List)d ;
			int index = lt.getSelectedIndex() ;
			if( index==0){
				backtoEdit() ;
				return ;
			} else {
				Display.getDisplay(vv.mld).setCurrent(this) ;
				return ;
			}
		} else {
			switch( c.getPriority()){
				case  19 :
					if( currentFocus==0){
						superDirectory();
					} else if( !isFolder( fileList[currentFocus-1])){
						backtoView() ;
						return ;
					} else {
						subDirectory( fileList[currentFocus-1]) ;
						currentFocus=0; currentDisplay=0;
					}
					repaint();
					return ;
				case  18 :
//					if( vv.textfile.endsWith(".txt") || vv.textfile.endsWith(".TXT")){
					if( vv.endline>0){
						Display.getDisplay(vv.mld).setCurrent(vv) ;
						vv.blOn() ;
					}
					return ;
				case  21 :
					hh.openHistory() ;
					return ;

				case  20 :
					if( currentFocus!=0 && !isFolder( fileList[currentFocus-1])){
						showDialogEdit() ;
						return ;
					} else {
//repaint()?
						return ;
					}
				case  22 :
					create() ;
					return ;
				case  23 :
					rename() ;
					return ;
				case  24 :
					delete() ;
					return ;
			}

		}
	}
	private void backtoView (){
		if( fileList[currentFocus-1].endsWith(".txt") || fileList[currentFocus-1].endsWith(".TXT")){
			vv.lastopen = true ;
		}
		hh.addHistory( currentDirectory + fileList[currentFocus-1]) ;
		vv.loadFile();
		Display.getDisplay(vv.mld).setCurrent(vv) ;
		return ;
	}
	private void backtoEdit () {
		vv.body = null ;
		vv.endline=-1;
		System.gc();
		edit.openFile(currentDirectory + fileList[currentFocus-1]);
		return ;
	}
	private void create () {
		if( mediaRootFlag){
			return ;
		}
		String name = getFepText("VKt@C.txt") ;
		if(name==null||name.equals("")){
			return ;
		}
		StorageConnection conn = null;
		OutputStream       out = null ;
		try {
			conn = (StorageConnection)Connector.open( "file://"+currentDirectory+name, Connector.WRITE) ;
			if( name.endsWith("/")){
				conn.createFolder();
			} else {
				out = conn.openOutputStream() ;
				out.close();
				out=null ;
			}
			conn.close();
			conn=null ;
			Display.getDisplay(vv.mld).setCurrent( new Alert("쐬܂:\n "+name)) ;
		} catch (Exception e) {
{ /*e.getMessage()+": "+currentDirectory*/ };
			Display.getDisplay(vv.mld).setCurrent( new Alert("쐬s:\n "+name)) ;
		} finally {
			if( out!=null){
				try { out.close(); } catch (Exception e) {}
			}
			if (conn != null) {
				try { conn.close(); } catch (Exception e) {}
			}
			openDirectory( currentDirectory) ;
		}
		return ;
	}

	private void rename () {
		if( mediaRootFlag || currentFocus==0){
			return ;
		}
		StorageConnection conn = null;
		String name = getFepText( fileList[currentFocus-1]) ;
		if(name==null||name.equals("")||name.equals(fileList[currentFocus-1])){
			return ;
		}
		try {
			conn = (StorageConnection)Connector.open( "file://"+currentDirectory+fileList[currentFocus-1], Connector.WRITE) ;
			conn.renameTo( name) ;
			conn.close();
			conn=null;
			Display.getDisplay(vv.mld).setCurrent( new Alert("OύX܂:\n "+name)) ;
		} catch (Exception e) {
{ /*e.getMessage()+": "+currentDirectory*/ };
			Display.getDisplay(vv.mld).setCurrent( new Alert("OύXs:\n "+name)) ;
		} finally {
			if (conn != null) {
				try { conn.close(); } catch (Exception e) {}
			}
			openDirectory( currentDirectory) ;
		}
		return ;
	}
	private void delete () {
		if( mediaRootFlag || currentFocus==0){
			return ;
		}
		StorageConnection conn = null;
		try {
			conn = (StorageConnection)Connector.open( "file://"+currentDirectory+fileList[currentFocus-1], Connector.WRITE) ;
			conn.delete();
			conn.close() ;
			conn=null;
			Display.getDisplay(vv.mld).setCurrent( new Alert("폜܂:\n "+fileList[currentFocus-1])) ;
			currentFocus = 0 ;
			currentDisplay = 0 ;
		} catch (Exception e) {
{ /*e.getMessage()+": "+currentDirectory*/ };
			Display.getDisplay(vv.mld).setCurrent( new Alert("폜s:\n "+fileList[currentFocus-1])) ;
		} finally {
			if (conn != null) {
				try { conn.close(); } catch (Exception e) {}
			}
			openDirectory( currentDirectory) ;
		}
		return ;
	}
	private String getFepText(String base){
		String value = "" ;
		try {
			value = FEPControl.getDefaultFEPControl().getInputText( base, TextField.ANY, 40, false) ;
		} catch( Exception e){
		}
		return  value ;
	}







	private void  sortFileList () {
		qsort(0, fileList.length-1) ;
	}
	private void  qsort( int i, int j){
//	iԖڂString]pɍ̗p
		int tmp = j-i ;
		if( tmp==1){
			if( compareFile( i, j)<0){
				swap( i, j) ;
			}
			return ;
		} else if( tmp<1){
			return ;
		}
		int m = i+1 ;
		int n = j ;
		while( m<n){
			for( ; m<=j&&compareFile( m, i)>=0; m++){}
			for( ; n>i&&compareFile( n, i)<0; n--){}
			if( m<n){
				swap( m, n) ;
			}
		}
		swap( i, m-1) ;
		qsort( i, m-2) ;
		qsort( n+1, j) ;
		return ;
	}

	private int compareFile( int i, int j){
//		i<=j plus, i>j minus
		boolean ii = fileList[i].endsWith("/") ;
		boolean jj = fileList[j].endsWith("/") ;
		if(  ii && !jj){
			return 1 ;
		} else if ( jj && !ii){
			return  -1 ;
		} else {
			return  fileList[j].compareTo( fileList[i]) ;
		}
	}
	private void swap( int i, int j){
		String tmp = fileList[i] ;
		fileList[i] = fileList[j] ;
		fileList[j] = tmp ;
		return ;
	}
	public int getMyGameAction(int keycode){
		switch( keycode){
			case  KEY_NUM0 :
			case  KEY_NUM1 :
			case  KEY_NUM2 :
			case  KEY_NUM3 :
			case  KEY_NUM4 :
			case  KEY_NUM5 :
			case  KEY_NUM6 :
			case  KEY_NUM7 :
			case  KEY_NUM8 :
			case  KEY_NUM9 :
			case  KEY_POUND :
			case  KEY_STAR :
				return  keycode ;
			default:
				return  getGameAction(keycode) ;
		}
	}
/*
	private String[] mylist(StorageConnection conn) throws IOException {
		String[] list = conn.list() ;
		conn.close();
		conn = null ;
		StorageConnection c = null ;
		InputStream in = null ;
		for( int i=list.length-1; i>=0; i--){
			try {
				c = (StorageConnection)Connector.open( "file://"+currentDirectory+list[i], Connector.READ) ;
				in = c.openInputStream() ;
				in.close();
				in = null;
				c.close();
				c = null ;
//	OoopenInputStream̂ŁA̓t@CłB
//	t@C̏ꍇ̏EEE͉Ȃ
			} catch( Exception e){
//	OoopenInputStreamɎŝŁA̓tH_łB
//	tH_̏ꍇ̏
				if( !list[i].endsWith("/")){
					list[i] += "/";
				}
			} finally {
				if( in!=null){in.close();in=null;}if( c!=null){c.close();c=null;}
			}

		}
		return  list ;
	}
*/
	private boolean  isFolder(String path){
//	w肳ꂽpXtH_ǂ`FbN
//	擾ɐtrue, sfalse
//	"/"ȂătH_ǂ킩Ȃ@킪̂ŁAJƂĂ݂ėOot@CłƔfB
		if( path.endsWith("/")){
			return  true ;
		}
		StorageConnection conn = null;
		InputStream in = null ;
		try {
			conn = (StorageConnection)Connector.open( "file://"+currentDirectory+path, Connector.READ) ;
			if( !conn.exists()){
				return  true ;
			}
			in = conn.openInputStream() ;
			in.close();
			in = null;
			conn.close();
			conn = null ;
//	I[vɐ̂ŁA̓t@CłB
			return  false ;
		} catch (Exception e) {
//	OôŁAw肳ꂽpXɂ̂̓tH_ɑȂȂ
{ /*e.getMessage()+": "+currentDirectory*/ };
			fileList[currentFocus-1] += "/";
			return  true ;
		} finally {
			if (in != null) {
				try { in.close(); } catch (Exception e) {}
			}
			if (conn != null) {
				try { conn.close(); } catch (Exception e) {}
			}
		}
	}
	public void run(){
		vv.myrun();
		return ;
	}
}

